<?php

namespace Drupal\Tests\lb_translation\Unit;

use Drupal\lb_auto_translation\Traits\TranslationHtmlTrait;
use Drupal\Tests\UnitTestCase;

/**
 * @coversDefaultClass Drupal\lb_auto_translation\Traits\TranslationHtmlTrait
 */
class TranslationHtmlTraitTest extends UnitTestCase {
  /**
   * @covers ::restoreHtmlTags
   */
  function testRestoreHtmlTags() {
    $tags = [0 => '<a href="/home-page">', '1' => '</a>', '2' => '<span>', '3' => '</span>'];
    $protected_string = '[#0][#2]Home[#3][#1]';
    $restored_string = '<a href="/home-page"><span>Home</span></a>';
    $handler = new TranslationHtmlMockableTraitTest();
    $this->assertEquals($restored_string, $handler->restoreHtmlTags($protected_string, $tags));
  }

  /**
   * @covers ::protectHtmlTags
   */
  function testProtectHtmlTags() {
    $text = '<a href="/home-page"><span>Home</span></a>';
    $tags = [0 => '<a href="/home-page">', '1' => '<span>', '2' => '</span>', '3' => '</a>'];
    $protected_string = '[#0][#1]Home[#2][#3]';
    $handler = new TranslationHtmlMockableTraitTest();
    $this->assertEquals([$protected_string, $tags], $handler->protectHtmlTags($text));
  }

}

class TranslationHtmlMockableTraitTest {
  use TranslationHtmlTrait;
}
